﻿using System;
using System.Collections.Generic;
using System.ComponentModel;

namespace WpfApplication2
{
   /// <summary>
   /// Container object for values
   /// </summary>
   class ValueContainer : INotifyPropertyChanged
   {
      private const double mc_RefernceValue = 10;
      private double m_DoubleValue;
      public Double DoubleValue
      {
         get { return m_DoubleValue; }
         set
         {
            m_DoubleValue = value;

            OnPropertyChanged("DoubleValue");
            OnPropertyChanged("Value");
         }
      }

      public Object Value
      {
         get
         {
            return mc_RefernceValue - DoubleValue;
         }
      }

      public event PropertyChangedEventHandler PropertyChanged;

      protected virtual void OnPropertyChanged(string propertyName)
      {
         PropertyChangedEventHandler handler = PropertyChanged;
         if (handler != null)
         {
            handler(this, new PropertyChangedEventArgs(propertyName));
         }
      }
   }

   /// <summary>
   /// Row object
   /// </summary>
   class RowData
   {
      public RowData()
      {
         Columns = new List<ValueContainer>();
      }

      public List<ValueContainer> Columns { get; set; }
   }

   /// <summary>
   /// Table
   /// </summary>
   class Data
   {
      public Data()
      {
         Rows = new List<RowData>();
      }

      /// <summary>
      /// Rows
      /// </summary>
      public List<RowData> Rows { get; set; }
   }
}
